#ifndef BOOKREPOSITORY_COLLECTIONIMPL_H_
#define BOOKREPOSITORY_COLLECTIONIMPL_H_

// Get rid of annoying VC++ Compiler Warning
#pragma warning( disable : 4290 ) 

#include "BookRepositoryS.hh"


class BookRepository_CollectionImpl :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_BookRepository::Collection
{
public:
    BookRepository_CollectionImpl(PortableServer::POA_ptr);

    virtual ~BookRepository_CollectionImpl();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    static POA_BookRepository::Collection*
    _create(PortableServer::POA_ptr);

    virtual PortableServer::POA_ptr
    _default_POA();

    //----------
    // IDL operations
    //----------
    virtual BookRepository::FuzzyBoolean
    is_in_collection(
        BookRepository::ISBN  book_id
    ) throw (
        CORBA::SystemException
    );


    //----------
    // IDL attributes
    //----------
    virtual CORBA::Long number_of_books()
    throw (CORBA::SystemException);

    virtual char* name_of_collection()
    throw (CORBA::SystemException);

    virtual void name_of_collection(
        const char*                     _new_value
    ) throw (CORBA::SystemException);

private: 
    // Instance variables for attributes.
    CORBA::Long                     m_number_of_books;
    CORBA::String_var               m_name_of_collectionV;

    // Private member variables
    PortableServer::POA_var         m_poaV;

    // The following are not implemented
    BookRepository_CollectionImpl(
        const BookRepository_CollectionImpl &
    );
    BookRepository_CollectionImpl& operator=(
        const BookRepository_CollectionImpl &
    );
}; 

#endif
