
#include <stdlib.h>
#include <iostream.h>
#include "BookRepository_SearchableCollectionImpl.h"


// _create() -- create a new servant.
POA_BookRepository::SearchableCollection*
BookRepository_SearchableCollectionImpl::_create(
    PortableServer::POA_ptr the_poa
)
{
    return new BookRepository_SearchableCollectionImpl(the_poa);
}


// Constructor
BookRepository_SearchableCollectionImpl::BookRepository_SearchableCollectionImpl(
    PortableServer::POA_ptr the_poa
) :
    BookRepository_CollectionImpl(the_poa)
{
}


// Destructor.
BookRepository_SearchableCollectionImpl::~BookRepository_SearchableCollectionImpl()
{
}

// is_in_collection() -- inherited from 'BookRepository::Collection' interface
BookRepository::FuzzyBoolean
BookRepository_SearchableCollectionImpl::is_in_collection(
    BookRepository::ISBN            book_id
) throw (CORBA::SystemException)
{
    if (m_collection_db.is_in_collection(book_id) ) {
        return BookRepository::YES;
    }
    else {
        return BookRepository::NO;
    }
}

// find_by_title()
CORBA::Boolean
BookRepository_SearchableCollectionImpl::find_by_title(
    const char*                     title,
    BookRepository::BookDetailsSeq_out books_found
) throw (CORBA::SystemException)
{
    cout << "BookRepository_SearchableCollectionImpl::find_by_title(): called."
         << endl;

    books_found = m_collection_db.getByTitle(title);
    return (books_found->length() > 0);
}

