#ifndef _COLLECTION_DB_
#define _COLLECTION_DB_


// Use the Standard Template Library (STL)
#include <map>

// Inlude definitions from the stub code.
#include "BookRepository.hh"

class Collection_DB {
public:
    Collection_DB();

    CORBA::Boolean
    is_in_collection(CORBA::Long book_id);

    BookRepository::BookDetails*
    get(CORBA::Long book_id);
    
    BookRepository::BookDetailsSeq*
    getByTitle(const char * title);


private:
    typedef std::map<CORBA::Long, BookRepository::BookDetails> TableType;

    // Private member variables
    TableType                 m_book_table;

    // Private member functions
    CORBA::Boolean foundMatchingTitle(
        const char* search_str,
        const char* title
    );

    // Not implemented for this class.
    Collection_DB(const Collection_DB&);
    Collection_DB& operator=(const Collection_DB&);
};


#endif
