package Pure.BookRepository;

import org.omg.CORBA.ORB;
import Pure.BookRepository.Borrower_DB;
import Pure.BookRepository.BorrowableCollectionPackage.*;


public class BorrowableCollectionImpl
   implements BorrowableCollectionOperations
{
    // Private member variables
    private int                             m_number_of_books;
    private java.lang.String                m_name_of_collection;
    private Borrower_DB                     m_borrower_db;
    private org.omg.PortableServer.POA      m_poa = null;

    public static Pure.BookRepository.BorrowableCollectionPOATie
    _create(org.omg.PortableServer.POA the_poa)
    throws org.omg.CORBA.SystemException
    {
      BorrowableCollectionImpl tied_object = new BorrowableCollectionImpl();
      Pure.BookRepository.BorrowableCollectionPOATie the_tie
          = new Pure.BookRepository.BorrowableCollectionPOATie(
                    tied_object, the_poa
                );

      return the_tie;
    }

    public BorrowableCollectionImpl() 
    {
        m_number_of_books    = 1000;
        m_name_of_collection = "AssortedBooks";
        m_borrower_db        = new Borrower_DB();
    }

    public FuzzyBoolean
    is_in_collection(
             int                             book_id
    )
    throws org.omg.CORBA.SystemException
    {
        return FuzzyBoolean.UNKNOWN;
    }

    public Pure.BookRepository.Date
    current_date()
    {
        Pure.BookRepository.Date today
            = new Pure.BookRepository.Date();

        java.util.Calendar c = java.util.Calendar.getInstance();
        today.day   = (short) c.get(java.util.Calendar.DATE);
        today.month = (short) (c.get(java.util.Calendar.MONTH) + 1);
        today.year  = (short) c.get(java.util.Calendar.YEAR);

        return today;
    }

    public Pure.BookRepository.Date
    increment_date(
        Pure.BookRepository.Date given_date,
        int days
    )
    {
        Pure.BookRepository.Date new_date
            = new Pure.BookRepository.Date();

        java.util.Calendar c = java.util.Calendar.getInstance();
        c.set((int) given_date.year,
              (int) given_date.month - 1,
              (int) given_date.day
        );
        c.add(java.util.Calendar.DATE, days);

        new_date.day   = (short) c.get(java.util.Calendar.DATE);
        new_date.month = (short) (c.get(java.util.Calendar.MONTH) + 1);
        new_date.year  = (short) c.get(java.util.Calendar.YEAR);
        return new_date;
    }

    public void borrow_book(
            int                             book_id,
            Pure.BookRepository.PersonName borrower,
            Pure.BookRepository.DateHolder return_date
    )
    throws org.omg.CORBA.SystemException,
    Pure.BookRepository.BorrowableCollectionPackage.Unavailable
    {
        // Check availability of book:
        Borrower_DB.LoanRecord loan = m_borrower_db.get(book_id);
        if ( loan != null ) {
            throw new Unavailable(loan.return_date);
        }

        return_date.value = increment_date(current_date(), 14);

        loan = new Borrower_DB.LoanRecord();
        loan.borrower = borrower;
        loan.return_date = return_date.value;
        m_borrower_db.put(book_id, loan);
    }

    public int number_of_books()
    {
        return m_number_of_books;
    }

    public java.lang.String name_of_collection()
    {
        return m_name_of_collection;
    }

    public 
    void name_of_collection(
           java.lang.String                _new_value)
    {
       m_name_of_collection = _new_value;
    }

    public org.omg.PortableServer.POA _default_POA()
    {
      return m_poa;
    }
}
