package Pure.BookRepository;

import java.io.*;
import Pure.BookRepository.*;

public class Collection_DB
{
    // Private member variables
    private java.util.Hashtable                 m_book_table;

    // Public methods
    public Collection_DB()
    {
        m_book_table = new java.util.Hashtable();

        FileReader inFile    = null;
        BufferedReader inBuf = null;
        try {
            inFile = new FileReader("collection.db");
            inBuf  = new BufferedReader(inFile);
        }
        catch (IOException ex) {
            System.out.println(
                "error: cannot open 'collection.db' file." + ex.toString()
            );
        }

        try {
            String s;
            int beginIndex = 0;
            int endIndex   = 0;
            while ( (s = inBuf.readLine()) != null) {
                System.out.println("Record:");

                BookDetails tmp = new BookDetails();
                tmp.author = new PersonName();
                tmp.publication_date
                    = new Pure.BookRepository.Date();

                beginIndex = s.indexOf(':');
                endIndex   = s.indexOf(':', beginIndex+1);
                tmp.author.first_name  = s.substring(beginIndex+1, endIndex);
                System.out.println(
                    "\tauthor.first_name = \""
                    + tmp.author.first_name + "\""
                );

                beginIndex = endIndex;
                endIndex   = s.indexOf(':', beginIndex+1);
                tmp.author.second_name = s.substring(beginIndex+1, endIndex);
                System.out.println(
                    "\tauthor.second_name = \""
                    + tmp.author.second_name + "\""
                );

                beginIndex = endIndex;
                endIndex   = s.indexOf(':', beginIndex+1);
                tmp.title              = s.substring(beginIndex+1, endIndex);
                System.out.println(
                    "\ttitle = \""
                    + tmp.title + "\""
                );

                beginIndex = endIndex;
                endIndex   = s.indexOf(':', beginIndex+1);
                tmp.book_id
                    = Integer.parseInt(s.substring(beginIndex+1, endIndex));
                System.out.println(
                    "\tbook_id = \""
                    + tmp.book_id + "\""
                );

                beginIndex = endIndex;
                endIndex   = s.indexOf(':', beginIndex+1);
                tmp.publication_date.day
                    = Short.parseShort(s.substring(beginIndex+1, endIndex));
                System.out.println(
                    "\tpublication_date.day = \""
                    + tmp.publication_date.day + "\""
                );

                beginIndex = endIndex;
                endIndex   = s.indexOf(':', beginIndex+1);
                tmp.publication_date.month
                    = Short.parseShort(s.substring(beginIndex+1, endIndex));
                System.out.println(
                    "\tpublication_date.month = \""
                    + tmp.publication_date.month + "\""
                );

                beginIndex = endIndex;
                tmp.publication_date.year
                    = Short.parseShort(s.substring(beginIndex+1));
                System.out.println(
                    "\tpublication_date.year = \""
                    + tmp.publication_date.year + "\""
                );
    
                m_book_table.put(new Integer(tmp.book_id), tmp);
            }
        }
        catch (Exception ex) {
            System.out.println(
                "error: Collection_DB constructor: " + ex.toString()
            );
        }
    }

    public boolean foundMatchingTitle(String search_str, String title)
    {
        if (search_str.length() > title.length()) { return false; }

        for (int toffset = 0;
             toffset <= title.length() - search_str.length();
             toffset++)
        {
            if (title.regionMatches(
                          true,        // IgnoreCase flag
                          toffset,
                          search_str,
                          0,           // Offset within 'search_str'
                          search_str.length()
               ))
            { return true; }
        }
        
        return false;
    }

    public boolean is_in_collection(int book_id)
    {
        return m_book_table.containsKey(new Integer(book_id));
    }

    public BookDetails get(int book_id)
    {
        return (BookDetails) m_book_table.get(new Integer(book_id));
    }
    
    public BookDetails[] getByTitle(String title)
    {
        BookDetails[] detailsSeq = null;

        int count = 0;
        java.util.Enumeration m = m_book_table.elements();
        while (m.hasMoreElements() ) {
            BookDetails tmpElem = (BookDetails) m.nextElement();
            if (foundMatchingTitle(title, tmpElem.title) ) {
                BookDetails[] tmpSeq = new BookDetails[count+1];
                for (int i=0; i < count; i++)
                { tmpSeq[i] = detailsSeq[i]; }
                tmpSeq[count++] = tmpElem;
                detailsSeq = tmpSeq;
            }
        }
    
        return detailsSeq;
    }

}


