package Pure.BookRepository;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.io.*;
import Pure.BookRepository.*;
import Pure.BookRepository.BorrowableCollectionPackage.*;

public class bk_borrow
{

   // global_orb -- make ORB public
   public static org.omg.CORBA.ORB global_orb = null;


   // read_reference() -- read an object reference from file.
   static org.omg.CORBA.Object read_reference(String file)
   {
      System.out.println("Reading stringified object reference from " + file);
      String ref = null;
      try
      {
         FileReader retrieve=new FileReader(file);
         BufferedReader in=new BufferedReader(retrieve);
         ref = in.readLine();
      }
      catch (IOException ex) {
         System.out.println("Error reading object reference from "
             + file + " : " + ex.toString()
         );
         return null;
      }
      org.omg.CORBA.Object obj = global_orb.string_to_object(ref);  
      return obj;
   }

    public static String[] remove_ORB_args(String args[])
    {
        String temp[] = new String[args.length];
        int i         = 0;
        int arg_count = 0;
        while (i < args.length)
        {
            java.util.StringTokenizer st
                = new java.util.StringTokenizer(args[i]);
            int n_skip = 0;
            if (st.countTokens() > 0)
            {
                if (st.nextToken().startsWith("-ORB") ) {
                    n_skip++;
                    if (st.countTokens() == 0) { n_skip++; }
                }
            }

            if (n_skip==0) {
                temp[arg_count++] = args[i++];
            }
            else {
                i += n_skip;
            }
        }

        String result[] = new String[arg_count];
        for (i=0; i<arg_count; i++) {  result[i] = temp[i]; }

        return result;
    }

   public static void main (String args[])
   {
      try
      {
         org.omg.CORBA.Object obj;  // For temporary object references.

         // Initialise the ORB.
         global_orb = ORB.init(args, null);

         String app_args[] = remove_ORB_args(args);
         

        // Parse command line arguments:
        if (app_args.length != 3) {
            System.out.println("Usage: bk_borrow "
                 + "<your_first_name> <your_second_name> <book_id>");
            System.exit(1);
        }
        String borrower_first_name  = app_args[0];
        String borrower_second_name = app_args[1];
        String isbn_string          = app_args[2];

        // Obtain Naming Service reference.
        org.omg.CosNaming.NamingContext rootContext = null;
        obj = global_orb.resolve_initial_references("NameService");
        rootContext = org.omg.CosNaming.NamingContextHelper.narrow(obj);

        // Obtain 'BookRepository::BorrowableCollection' object reference.
        org.omg.CosNaming.NameComponent[] objectName
            = new org.omg.CosNaming.NameComponent[2];
        objectName[0]
            = new org.omg.CosNaming.NameComponent("BookRepository", "");
        objectName[1]
            = new org.omg.CosNaming.NameComponent("Borrowable", "");
        obj = rootContext.resolve(objectName);
        BorrowableCollection theBorrowableCollection
            = BorrowableCollectionHelper.narrow(obj);
 
        // Invoke 'BookRepository.BorrowableCollection' object.
        int book_id;
        book_id = Integer.parseInt(isbn_string);
        PersonName borrower
            = new PersonName();
        borrower.first_name  = borrower_first_name;
        borrower.second_name = borrower_second_name;
        DateHolder return_dateH
            = new DateHolder();
        try {
            theBorrowableCollection.borrow_book(
                                       book_id,
                                       borrower,
                                       return_dateH
                                   );
            System.out.println("Book [ISBN="
                + book_id + "] has been borrowed.");
            System.out.println("Please return by: "
                 + return_dateH.value.day   + "/"
                 + return_dateH.value.month + "/"
                 + return_dateH.value.year);
        }
        catch (Unavailable bk_ex) {
            System.out.println("Sorry, book [ISBN="
                 + book_id + "] is unavailable until "
                 + bk_ex.when_available.day   + "/"
                 + bk_ex.when_available.month + "/"
                 + bk_ex.when_available.year);
        }
      }
      catch(Exception ex) 
      {
         System.out.println("Unexpected CORBA exception: " + ex);
      }

      try 
      {
         global_orb.shutdown(true);
         //global_orb.destroy();
      }
      catch (Exception ex) 
      { 
         // Do nothing.
      }        
      return;
   }
}
