package Pure.BookRepository;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.io.*;
import Pure.BookRepository.*;

public class bk_search
{

   // global_orb -- make ORB public
   public static org.omg.CORBA.ORB global_orb = null;


   // read_reference() -- read an object reference from file.
   static org.omg.CORBA.Object read_reference(String file)
   {
      System.out.println("Reading stringified object reference from " + file);
      String ref = null;
      try
      {
         FileReader retrieve=new FileReader(file);
         BufferedReader in=new BufferedReader(retrieve);
         ref = in.readLine();
      } catch (IOException ex)
      {
         System.out.println("Error reading object reference from "
             + file + " : " + ex.toString()
         );
         return null;
      }
      org.omg.CORBA.Object obj = global_orb.string_to_object(ref);  
      return obj;
   }

    public static String[] remove_ORB_args(String args[])
    {
        String temp[] = new String[args.length];
        int i         = 0;
        int arg_count = 0;
        while (i < args.length)
        {
            java.util.StringTokenizer st
                = new java.util.StringTokenizer(args[i]);
            int n_skip = 0;
            if (st.countTokens() > 0)
            {
                if (st.nextToken().startsWith("-ORB") ) {
                    n_skip++;
                    if (st.countTokens() == 0) { n_skip++; }
                }
            }

            if (n_skip==0) {
                temp[arg_count++] = args[i++];
            }
            else {
                i += n_skip;
            }
        }

        String result[] = new String[arg_count];
        for (i=0; i<arg_count; i++) {  result[i] = temp[i]; }

        return result;
    }


   public static void main (String args[])
   {
      try
      {
         org.omg.CORBA.Object obj;

         // Initialise the ORB.
         global_orb = ORB.init(args, null);

         String app_args[] = remove_ORB_args(args);

        // Parse command line arguments:
        if (app_args.length != 1) {
            System.out.println("Usage: bk_search " + " <book_title>");
            System.exit(1);
        }
        String book_title = app_args[0];

        // Obtain Naming Service reference.
        org.omg.CosNaming.NamingContext rootContext = null;
        obj = global_orb.resolve_initial_references("NameService");
        rootContext = org.omg.CosNaming.NamingContextHelper.narrow(obj);

        // Obtain 'BookRepository::SearchableCollection' object reference.
        org.omg.CosNaming.NameComponent[] objectName
            = new org.omg.CosNaming.NameComponent[2];
        objectName[0]
            = new org.omg.CosNaming.NameComponent("BookRepository", "");
        objectName[1]
            = new org.omg.CosNaming.NameComponent("Searchable", "");
        obj = rootContext.resolve(objectName);
        SearchableCollection theSearchableCollection
             = SearchableCollectionHelper.narrow(obj);

        // Invoke on BookRepository::SearchableCollection object.
        BookDetailsSeqHolder detailsSeqH
            = new BookDetailsSeqHolder();
        boolean wasFound;
        wasFound = theSearchableCollection.find_by_title(
                                      book_title,
                                      detailsSeqH
                                  );
        if (wasFound) {
            System.out.println("Found the following matching titles:");
        }
        else {
            System.out.println("No matching titles.");
        }

        // Print out the list of books (if any)
        for (int i=0; i < detailsSeqH.value.length; i++) {
            System.out.println("Book[" + i + "]");
            System.out.println("\tAuthor: "
                 + detailsSeqH.value[i].author.second_name + ", "
                 + detailsSeqH.value[i].author.first_name);
            System.out.println("\tTitle:  " + detailsSeqH.value[i].title);
            System.out.println("\tISBN:   " + detailsSeqH.value[i].book_id);
            System.out.println("\tPublication Date: "
                 + detailsSeqH.value[i].publication_date.day   + "/"
                 + detailsSeqH.value[i].publication_date.month + "/"
                 + detailsSeqH.value[i].publication_date.year);
        }
      }
      catch(Exception ex) 
      {
         System.out.println("Unexpected CORBA exception: " + ex);
      }

      try 
      {
         global_orb.shutdown(true);
         //global_orb.destroy();
      }
      catch (Exception ex) 
      { 
         // Do nothing.
      }        
      return;
   }
}
