
#ifndef _NAMEUTIL_H_
#define _NAMEUTIL_H_

//----------------------------------------
// Includes
//----------------------------------------


#include <iostream.h>
#include <fstream.h>
#include <omg/orb.hh>
#include <omg/PortableServer.hh>
#include <omg/CosNaming.hh>

//----------------------------------------
// Class: NameUtil
//----------------------------------------

class NameUtil
{
public:
     //----------------------------------------
     // C'tor and D'tor
     //----------------------------------------
     NameUtil();
     virtual ~NameUtil();

     //----------------------------------------
     // method: 'printName()'
     //
     // purpose: Print 'name' to 'cout' in standard stringified
     //          format.
     //----------------------------------------
     static void printName(const CosNaming::Name& name);

     //----------------------------------------
     // method: 'createContextPath()'
     //
     // purpose: For each 'NameComponent' in 'name',
     //          create a corresponding 'NamingContext'.
     //----------------------------------------
     static void createContextPath(
          const CosNaming::NamingContext_ptr nc,
          const CosNaming::Name&  name
	  );

     //----------------------------------------
     // method: 'bindObjectPath()'
     //
     // purpose: For the first [0, length-2] NameComponents of
     //          'name', create a corresponding 'NamingContext'.
     //          For the length-1 NameComponent of 'name', bind it
     //          to the object reference 'obj'.
     //----------------------------------------
     static void bindObjectPath(
          const CosNaming::NamingContext_ptr nc,
          const CosNaming::Name&  name,
	  const CORBA::Object_ptr obj
	  );

     //----------------------------------------
     // method: 'listBindings()'
     //
     // purpose: 
     //----------------------------------------
     static CosNaming::BindingList *  listBindings(
          const CosNaming::NamingContext_ptr nc,
          const CosNaming::Name&  name,
	  CORBA::ULong max_list_size
	  );

     //----------------------------------------
     // method: 'printBindings()'
     //
     // purpose: 
     //----------------------------------------
     static void printBindings(
          const CosNaming::NamingContext_ptr nc,
          const CosNaming::Name&  name
	  );

     //----------------------------------------
     // method: 'recursiveUnbind()'
     //
     // purpose: 
     //----------------------------------------
     static void recursiveUnbind(
          const CosNaming::NamingContext_ptr nc,
          const CosNaming::Name&  name
	  );

private:
     // The following are not implemented:
     NameUtil& operator=(const NameUtil&);
     NameUtil(const NameUtil&);
};

#endif
