//----------------------------------------------
// Implementation of 'POAMapper' class
//----------------------------------------------

#include "POAMapper.h"

#include <iostream.h>
#include <string.h>

void
POAMapper::addPOAEntry(const char* rep_id, PortableServer::POA_ptr poaP)
{
    thisMap().m_table[rep_id] = PortableServer::POA::_duplicate(poaP);
}
    
PortableServer::POA_ptr
POAMapper::getPOA(const char* rep_id)
{
    TableType::iterator iter = thisMap().m_table.find(rep_id);
    if (iter != thisMap().m_table.end() ) {
        // 'Repository Id' found in map.
        return PortableServer::POA::_duplicate(iter->second);
    }
    else {
        // 'Repository Id' not found.
        cerr << "fatal error: POAMapper::getPOA() - "
             << "No entry for \"" << rep_id << "\" Repository id." << endl;
        exit(1);
        return PortableServer::POA::_nil();
    }
}
    
POAMapper::~POAMapper()
{  }


//--------------------------
// Private functions
//--------------------------

POAMapper&
POAMapper::thisMap()
{
    static POAMapper singleton;
    return singleton;
}

POAMapper::POAMapper()
{  }

