// Servant which implements the RecycleBroker::Browsing interface.

#include <stdlib.h>
#include <iostream.h>
#include "RecycleBroker_Browsing_i.h"
#include "RecycleBroker_WasteItemAdmin_i.h"
#include "POAMapper.h"


// _create() -- create a new servant.
POA_RecycleBroker::Browsing*
RecycleBroker_Browsing_i::_create(RecycleBroker::KeyType branch_id)
{
    return new RecycleBroker_Browsing_i(branch_id);
}


// RecycleBroker_Browsing_i constructor
RecycleBroker_Browsing_i::RecycleBroker_Browsing_i(
    RecycleBroker::KeyType branch_id
) :
    m_branch_id(branch_id)
{
}


// ~RecycleBroker_Browsing_i destructor.
//
RecycleBroker_Browsing_i::~RecycleBroker_Browsing_i()
{
}


// get_waste_item_admin() -- Implements IDL operation "RecycleBroker::Browsing::get_waste_item_admin".
//
RecycleBroker::WasteItemAdmin_ptr
RecycleBroker_Browsing_i::get_waste_item_admin() IT_THROW_DECL((
    CORBA::SystemException
))
{
    cout << "RecycleBroker_Browsing_i::get_waste_item_admin(): called." << endl;

    PortableServer::ServantBase_var the_WasteItemAdminV;
    PortableServer::POA_var      child_poaV;
    PortableServer::ObjectId_var oidV;
    CORBA::Object_var            objV;
    RecycleBroker::WasteItemAdmin_var    refV;

    the_WasteItemAdminV
        = new RecycleBroker_WasteItemAdmin_i(m_branch_id);
    child_poaV = the_WasteItemAdminV->_default_POA();
    oidV = child_poaV->activate_object(the_WasteItemAdminV.in() );
    objV = child_poaV->id_to_reference(oidV);
    refV = RecycleBroker::WasteItemAdmin::_narrow(objV.in() );

    return refV._retn();
}

PortableServer::POA_ptr
RecycleBroker_Browsing_i::_default_POA()
{
    CORBA::String_var rep_idV = RecycleBroker::_tc_Browsing->id();
    return POAMapper::getPOA(rep_idV.in() );
}

