// Servant which implements the RecycleBroker::HeadOffice interface.
//

#include <stdlib.h>
#include <iostream.h>
#include "RecycleBroker_HeadOffice_i.h"
#include "POAMapper.h"


// _create() -- create a new servant.
// Hides the difference between direct inheritance and tie servants
// For direct inheritance, simple create and return an instance of the servant.
// For tie, creates an instance of the tied class and the tie, return the tie.
//
POA_RecycleBroker::HeadOffice*
RecycleBroker_HeadOffice_i::_create(const char* address, CORBA::Long branch_id)
{
    return new RecycleBroker_HeadOffice_i(address, branch_id);
}


// RecycleBroker_HeadOffice_i constructor
//
// Note: since we use virtual inheritance, we must include an
// initialiser for all the virtual base class constructors that
// require arguments, even those that we inherit indirectly.
//
RecycleBroker_HeadOffice_i::RecycleBroker_HeadOffice_i(
    const char* address, CORBA::Long branch_id
) :
    RecycleBroker_Office_i(address, branch_id)
{
}


// ~RecycleBroker_HeadOffice_i destructor.
//
RecycleBroker_HeadOffice_i::~RecycleBroker_HeadOffice_i()
{
    // Intentionally empty.
    //
}


// replicate_waste_item_details() -- Implements IDL operation "RecycleBroker::HeadOffice::replicate_waste_item_details".
//
void
RecycleBroker_HeadOffice_i::replicate_waste_item_details(
    const RecycleBroker::WasteItemDetailsFullSeq& detailsSeq
) IT_THROW_DECL((
    CORBA::SystemException
))
{
    // DUMMY IMPLEMENTATION
    cout << "RecycleBroker_HeadOffice_i::replicate_waste_item_details(): called." << endl;
}


// replicate_customer_details() -- Implements IDL operation "RecycleBroker::HeadOffice::replicate_customer_details".
//
void
RecycleBroker_HeadOffice_i::replicate_customer_details(
    const RecycleBroker::CustomerDetailsFullSeq& detailsSeq
) IT_THROW_DECL((
    CORBA::SystemException
))
{
    // DUMMY IMPLEMENTATION
    cout << "RecycleBroker_HeadOffice_i::replicate_customer_details(): called."
         << endl;
}

PortableServer::POA_ptr
RecycleBroker_HeadOffice_i::_default_POA()
{
    CORBA::String_var rep_idV = RecycleBroker::_tc_HeadOffice->id();
    return POAMapper::getPOA(rep_idV.in() );
}

