// Class: RecycleBroker_Office_i
// A POA servant which implements of the RecycleBroker::Office interface
//

#ifndef RECYCLEBROKER_OFFICE_I_H_
#define RECYCLEBROKER_OFFICE_I_H_

#include "RecycleBrokerS.hh"


class RecycleBroker_Office_i :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_RecycleBroker::Office
{
public:
    RecycleBroker_Office_i(const char* address, CORBA::Long branch_id);

    virtual ~RecycleBroker_Office_i();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    //    
    static POA_RecycleBroker::Office*
    _create(const char* address, CORBA::Long branch_id);


    // IDL operations
    //
    virtual RecycleBroker::Browsing_ptr
    get_browsing() IT_THROW_DECL((
        CORBA::SystemException
    ));

    virtual RecycleBroker::Selling_ptr
    get_selling() IT_THROW_DECL((
        CORBA::SystemException
    ));

    virtual RecycleBroker::Buying_ptr
    get_buying() IT_THROW_DECL((
        CORBA::SystemException
    ));

    virtual RecycleBroker::CustomerAdmin_ptr
    get_customer_admin() IT_THROW_DECL((
        CORBA::SystemException
    ));

    virtual RecycleBroker::WasteItemAdmin_ptr
    get_waste_item_admin() IT_THROW_DECL((
        CORBA::SystemException
    ));


    // IDL attributes
    //
    virtual char* address() IT_THROW_DECL((CORBA::SystemException));

    virtual CORBA::Long branch_id() IT_THROW_DECL((CORBA::SystemException));

    virtual PortableServer::POA_ptr
    _default_POA();

private: 
    // Instance variables for attributes.
    //
    CORBA::String_var               m_address;
    CORBA::Long                     m_branch_id;

    // The following are not implemented
    //
    RecycleBroker_Office_i(const RecycleBroker_Office_i &);
    RecycleBroker_Office_i& operator=(const RecycleBroker_Office_i &);
}; 

#endif
