// Class: RecycleBroker_WasteItem_i
// A POA servant which implements of the RecycleBroker::WasteItem interface
//

#ifndef RECYCLEBROKER_WASTEITEM_I_H_
#define RECYCLEBROKER_WASTEITEM_I_H_

#include "RecycleBrokerS.hh"


class RecycleBroker_WasteItem_i :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_RecycleBroker::WasteItem
{
public:
    RecycleBroker_WasteItem_i(RecycleBroker::KeyType wasteitem_id);
    RecycleBroker_WasteItem_i(const RecycleBroker::WasteItemDetailsFull& data);

    virtual ~RecycleBroker_WasteItem_i();

    // _create() -- create a new servant.
    static POA_RecycleBroker::WasteItem*
    _create(RecycleBroker::KeyType wasteitem_id);


    // IDL operations
    //
    virtual RecycleBroker::WasteItemDetails
    get_details() IT_THROW_DECL((
        CORBA::SystemException
    ));


    // IDL attributes
    //
    virtual RecycleBroker::WasteType waste() IT_THROW_DECL((CORBA::SystemException));

    virtual void waste(
        RecycleBroker::WasteType        _new_value
    ) IT_THROW_DECL((CORBA::SystemException));

    virtual CORBA::Long quantity() IT_THROW_DECL((CORBA::SystemException));

    virtual void quantity(
        CORBA::Long                     _new_value
    ) IT_THROW_DECL((CORBA::SystemException));

    virtual RecycleBroker::PriceType price_per_kilo() IT_THROW_DECL((CORBA::SystemException));

    virtual void price_per_kilo(
        RecycleBroker::PriceType        _new_value
    ) IT_THROW_DECL((CORBA::SystemException));

    virtual RecycleBroker::KeyType branch_id() IT_THROW_DECL((CORBA::SystemException));

    virtual RecycleBroker::KeyType customer_id() IT_THROW_DECL((CORBA::SystemException));

    virtual RecycleBroker::KeyType wasteitem_id() IT_THROW_DECL((CORBA::SystemException));

    virtual PortableServer::POA_ptr
    _default_POA();

private: 
    // Cached customer record
    CORBA::Boolean                         m_hasValidCache;
    RecycleBroker::WasteItemDetailsFull*   m_dataP;
    
    // Private functions
    void _update_db_from_cache();
 
    // The following are not implemented
    RecycleBroker_WasteItem_i(const RecycleBroker_WasteItem_i &);
    RecycleBroker_WasteItem_i& operator=(const RecycleBroker_WasteItem_i &);
}; 

#endif
