//package Pure.RecycleBroker;

import org.omg.CORBA.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class RecycleClient extends HttpServlet
{
    static org.omg.CORBA.Object read_reference(String file)
    {
        System.out.println("Reading stringified object reference from " + file);
        String ref = null;
        try
        {
          java.io.FileReader retrieve=new java.io.FileReader(file);
          java.io.BufferedReader in=new java.io.BufferedReader(retrieve);
          ref = in.readLine();
        }
        catch (java.io.IOException ex) {
          System.out.println(
              "Error reading object reference from " + file + " : " + ex
          );
          return null;
        }
        System.out.println("Server object reference = " + ref);
        org.omg.CORBA.Object obj = m_orb.string_to_object(ref);  
        return obj;
    }

    public RecycleClient()
    {
        try {
            // Initialize the ORB
            m_orb = org.omg.CORBA.ORB.init(new String[0], null);

            // Get Root Naming Context
            org.omg.CORBA.Object obj = null;
            org.omg.CosNaming.NamingContextExt rootContextExt = null;

            obj = m_orb.resolve_initial_references("NameService");
            rootContextExt
                = org.omg.CosNaming.NamingContextExtHelper.narrow(obj);

            // Get reference to 'RecycleBroker::BranchOffice'.
	    obj = rootContextExt.resolve_str(
	              "Pure/RecycleBroker/BranchOffice"
		    );
            m_branch_office = Pure.RecycleBroker.BranchOfficeHelper.narrow(obj);
        }
        catch (Exception ex) {
            System.out.println(ex);
            ex.printStackTrace();
        }
    }

    
    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        response.setContentType("text/html");

        String form_kind = request.getParameter("form_kind");
        if (form_kind.equals("open_account"))
        {
            do_open_account(request, response);
        }
        else if (form_kind.equals("logon_buy"))
        {
            do_logon_buy(request, response);
        }
        else if (form_kind.equals("logon_sell"))
        {
            do_logon_sell(request, response);
        }
        else if (form_kind.equals("sell"))
        {
            do_sell(request, response);
        }
        else if (form_kind.equals("buy"))
        {
            do_buy(request, response);
        }
        else if (form_kind.equals("logoff_sell"))
        {
            do_logoff_sell(request, response);
        }
        else if (form_kind.equals("logoff_buy"))
        {
            do_logoff_buy(request, response);
        }
    }

    public void doPost(HttpServletRequest request,
                      HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        doGet(request, response);
    }

    public void print_header(java.io.PrintWriter out, String heading)
    {
        out.println("<html>");
        out.println("<head>");

        out.println("<title>Recycle Broker</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<h1>" + heading + "</h1>");
    }

    public void print_footer(java.io.PrintWriter out)
    {
        out.println("</body>");
        out.println("</html>");
    }

    public void do_open_account(
                    HttpServletRequest request,
                    HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        java.io.PrintWriter out = response.getWriter();

        print_header(out, "Confirmation of New Account");

        try {
            // Get reference to 'RecycleBroker::BranchOffice'.
            org.omg.CORBA.Object obj;

            // Use 'RecycleBroker::CustomerAdmin' interface.
            Pure.RecycleBroker.CustomerAdmin customer_admin
                = m_branch_office.get_customer_admin();

            Pure.RecycleBroker.CustomerDetails details
                = new Pure.RecycleBroker.CustomerDetails();
            org.omg.CORBA.IntHolder  customer_idH
                = new org.omg.CORBA.IntHolder();
            details.name          = request.getParameter("name");
            details.address       = request.getParameter("address");
            details.email_address = request.getParameter("email_address");
            details.password      = request.getParameter("password");
            Pure.RecycleBroker.Customer cust
                = customer_admin.create(details, customer_idH);
            out.println(
                 "<p>Created customer with customer_id = "
                 + customer_idH.value + "</p>"
            );
            out.println("<p>Confirming Details:</p>");
            details = cust.get_details();
            out.println("<p>name:" + details.name + "</p>");
            out.println("<p>address:" + details.address + "</p>");
            out.println("<p>email_address:" + details.email_address+"</p>");
            out.println("<p>password: ???</p>");
            out.println("<br><p>Return to the "
                + "<a href=\"/RecycleBroker/index.html\">main menu</a>.</p>");
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace();
        }
            
        print_footer(out);
    }

    public void do_logon_sell(
                    HttpServletRequest request,
                    HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        java.io.PrintWriter out = response.getWriter();

        try {
            Pure.RecycleBroker.Selling selling
                = m_branch_office.get_selling();
            String name     = request.getParameter("name");
            String password = request.getParameter("password");
            Pure.RecycleBroker.Customer cust
                = selling.log_on(name, password);

            // Logon is successful => Create user session
            HttpSession thisSession = request.getSession(true);
            thisSession.setAttribute(
                "customer_id",
                new Integer(cust.customer_id())
            );
            thisSession.setAttribute("selling_obj", selling);
            response.sendRedirect("/RecycleBroker/recycle_sell.html");
        }
        catch (Pure.RecycleBroker.NoPermission np)
        {
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace();
        }
    }

    public void do_logon_buy(
                    HttpServletRequest request,
                    HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        java.io.PrintWriter out = response.getWriter();

        try {
            // Get logon details from form.
            Pure.RecycleBroker.Buying buying
                = m_branch_office.get_buying();
            String name     = request.getParameter("name");
            String password = request.getParameter("password");
            Pure.RecycleBroker.Customer cust
                = buying.log_on(name, password);

            // Logon is successful => Create user session
            HttpSession thisSession = request.getSession(true);
            thisSession.setAttribute(
                "customer_id",
                new Integer(cust.customer_id())
            );
            thisSession.setAttribute("buying_obj", buying);

            // Construct response.
            Pure.RecycleBroker.Browsing browsing
                = m_branch_office.get_browsing();
            Pure.RecycleBroker.WasteItemAdmin waste_admin
                = browsing.get_waste_item_admin();
            thisSession.setAttribute("wasteitem_admin_obj", waste_admin);
            int[] id_seq = waste_admin.find_all();
            Pure.RecycleBroker.WasteItemDetails[] details_seq
                = waste_admin.get_details(id_seq);

            print_header(out, "List of Waste Item for Sale");
            out.println(
                "<form method=\"post\" action=\"/servlet/RecycleClient\">"
            );
            out.println("<table border=\"0\" width=\"100%\"> ");
            out.println("<tr>");
            out.println("<th align=\"left\" width=\"150\">Waste Type</th> ");
            out.println("<th align=\"left\" width=\"50\">Quantity Available</th> ");
            out.println("<th align=\"left\" width=\"50\">Price per Kilo</th> ");
            out.println("<th align=\"left\" width=\"50\">Check to Buy</th> ");
            //out.println("<th align=\"left\">Quantity to Buy</th> ");
            out.println("</tr>");
            for (int i=0; i < details_seq.length; i++)
            {
                out.println("<tr> ");
                String wasteStr = WasteType_to_string(details_seq[i].waste);
                out.println("<td width=\"150\">" + wasteStr + "</td>");
                out.println("<td width=\"50\">"
                    + details_seq[i].quantity + "</td>");
                out.println("<td width=\"50\">"
                    + details_seq[i].price_per_kilo + "</td>");
                out.println("<td width=\"50\">"
                    + "<input type=\"checkbox\" name=\"selected_wasteitems\" "
                    + "value=\"" + id_seq[i] + "\"></td>");
                out.println("</tr> ");
            }
            out.println("</table ");
            out.println("<p><input type=\"hidden\" "
              + "name=\"form_kind\" value=\"buy\"></p>");
            out.println("<p><input type=\"submit\" value=\"Buy Items\"> "
              + "<input type=\"reset\"></p>");
            out.println("</form> ");
            print_footer(out);
         
        }
        catch (Pure.RecycleBroker.NoPermission np)
        {
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace();
        }
    }

    public void do_sell(
                    HttpServletRequest request,
                    HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        java.io.PrintWriter out = response.getWriter();
            
        try {
            // Get existing user session
            HttpSession thisSession = request.getSession(false);
            if (thisSession != null) {
                // Get details from the web form.
                Pure.RecycleBroker.WasteItemDetails details
                    = new Pure.RecycleBroker.WasteItemDetails();
                String wasteStr = request.getParameter("waste");
                details.waste = string_to_WasteType(wasteStr);
                details.quantity = Integer.parseInt(
                                       request.getParameter("quantity")
                                   );
                details.price_per_kilo = Float.parseFloat(
                                       request.getParameter("price_per_kilo")
                                   );
                org.omg.CORBA.IntHolder wasteitem_idH
                    = new org.omg.CORBA.IntHolder();

                // Create the Waste Item on the server.
                Pure.RecycleBroker.Selling selling
                    = (Pure.RecycleBroker.Selling)
                          thisSession.getAttribute("selling_obj");
                if (selling == null)
                {
                    out.println("<p>Error for customer_id = "
                        + thisSession.getAttribute("customer_id") + "</p>");
                    throw new Pure.RecycleBroker.NotLoggedOn();
                }
                Pure.RecycleBroker.WasteItem wasteitem
                    = selling.create_waste_item(details, wasteitem_idH);

                // Send response with confirmation details.
                details = wasteitem.get_details();
                //wasteStr = wasteitem_to_string(details.waste);
                print_header(out, "Confirmation of Offer");
                
                out.println("<table border=\"0\" width=\"100%\"> ");
                out.println("<tr> ");
                out.println("<td width=\"150\">Quantity (kilos):</td> ");
                out.println("<td>" + details.quantity + "</td> ");
                out.println("</tr> ");
                out.println("<tr> ");
                out.println("<td width=\"150\">Price (per Kilo):</td> ");
                out.println("<td>" + details.price_per_kilo + "</td> ");
                out.println("</tr> ");
                out.println("</table ");

                out.println("<br> "
                  + "<form method=\"post\" action=\"/servlet/RecycleClient\">");
                out.println("<p><input type=\"hidden\" "
                  + "name=\"form_kind\" value=\"logoff_sell\"></p>");
                out.println("<p><input type=\"submit\" value=\"Logoff\"></p>");
                out.println("</form> ");
            }
            else {
                // Null session => something went wrong!
                throw new Pure.RecycleBroker.NotLoggedOn();
            }

        }
        catch (Pure.RecycleBroker.NotLoggedOn np)
        {
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace();
        }
            
        print_footer(out);
    }

    public void do_buy(
                    HttpServletRequest request,
                    HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        java.io.PrintWriter out = response.getWriter();
            
        try {
            // Get existing user session
            HttpSession thisSession = request.getSession(false);
            if (thisSession != null) {
                // Get details from the web form.
                String[] selected_wasteitems
                    = request.getParameterValues("selected_wasteitems");
                int[] selected_ids = new int[selected_wasteitems.length];
                for (int i=0; i < selected_ids.length; i++)
                {
                    selected_ids[i] = Integer.parseInt(selected_wasteitems[i]);
                }

                // Get corresponding waste item details from server.
                Pure.RecycleBroker.WasteItemAdmin waste_admin
                    = (Pure.RecycleBroker.WasteItemAdmin)
                        thisSession.getAttribute("wasteitem_admin_obj");
                Pure.RecycleBroker.WasteItemDetails[] details_seq
                    = waste_admin.get_details(selected_ids);

                // Send response with confirmation details.
                print_header(out, "Confirmation of Purchase");
                out.println("<table border=\"0\" width=\"100%\"> ");
                out.println("<tr>");
                out.println(
                    "<th align=\"left\" width=\"150\">Waste Type</th> ");
                out.println(
                    "<th align=\"left\" width=\"50\">Quantity Requested</th> ");
                out.println(
                    "<th align=\"left\" width=\"50\">Price per Kilo</th> ");
                out.println(
                    "<th align=\"left\" width=\"50\">Bought</th> ");
                out.println("</tr>");

                // Buy each waste item
                Pure.RecycleBroker.Buying buying
                    = (Pure.RecycleBroker.Buying)
                        thisSession.getAttribute("buying_obj");
                int[] bought_ids = new int[selected_ids.length];
                int bought_count = 0;
                float total_cost = 0;
                for (int i=0; i < selected_ids.length; i++)
                {
                    String bought = "No";
                    try {
                        buying.buy_item(
                            selected_ids[i], 
                            details_seq[i].quantity
                        );
                        bought_ids[bought_count++] = selected_ids[i];
                        bought = "Yes";
                        total_cost += details_seq[i].quantity
                                      * details_seq[i].price_per_kilo;
                    }
                    catch (org.omg.CORBA.UserException uex) {
                        // Error: failed to buy an item!
                        System.out.println(uex);
                    }
                    out.println("<tr> ");
                    String wasteStr
                        = WasteType_to_string(details_seq[i].waste);
                    out.println("<td width=\"150\">" + wasteStr + "</td>");
                    out.println("<td width=\"50\">"
                        + details_seq[i].quantity + "</td>");
                    out.println("<td width=\"50\">"
                        + details_seq[i].price_per_kilo + "</td>");
                    out.println("<td width=\"50\">" + bought + "</td>");
                    out.println("</tr> ");
                }

                out.println("</table> ");
                out.println("<p>The total cost of your order is "
                    + total_cost + "</p>");
                out.println("<br> "
                  + "<form method=\"post\" action=\"/servlet/RecycleClient\">");
                out.println("<p><input type=\"hidden\" "
                  + "name=\"form_kind\" value=\"logoff_buy\"></p>");
                out.println("<p><input type=\"submit\" value=\"Logoff\"></p>");
                out.println("</form> ");
            }
            else {
                // Null session => something went wrong!
                throw new Pure.RecycleBroker.NotLoggedOn();
            }
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace();
        }
            
        print_footer(out);
    }

    public void do_logoff_sell(
                    HttpServletRequest request,
                    HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        java.io.PrintWriter out = response.getWriter();
            
        try {
            // Get existing user session
            HttpSession thisSession = request.getSession(false);
            if (thisSession != null) {
                // Log off the server.
                Pure.RecycleBroker.Selling selling
                    = (Pure.RecycleBroker.Selling)
                          thisSession.getAttribute("selling_obj");
                selling.log_off();
                thisSession.invalidate();
            }
            else {
                // Null session => something went wrong!
            }
            // Return to main menu page.
            response.sendRedirect("/RecycleBroker/index.html");
        }
        catch (Pure.RecycleBroker.NotLoggedOn np)
        {
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace();
        }
    }

    public void do_logoff_buy(
                    HttpServletRequest request,
                    HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        java.io.PrintWriter out = response.getWriter();
            
        try {
            // Get existing user session
            HttpSession thisSession = request.getSession(false);
            if (thisSession != null) {
                // Log off the server.
                Pure.RecycleBroker.Buying buying
                    = (Pure.RecycleBroker.Buying)
                          thisSession.getAttribute("buying_obj");
                buying.log_off();
                thisSession.invalidate();
            }
            else {
                // Null session => something went wrong!
            }
            // Return to main menu page.
            response.sendRedirect("/RecycleBroker/index.html");
        }
        catch (Pure.RecycleBroker.NotLoggedOn np)
        {
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace();
        }
    }

    public void print_html_file(java.io.PrintWriter out, String filename)
    {
        try
        {
            java.io.FileReader retrieve = new java.io.FileReader(filename);
            java.io.BufferedReader in   = new java.io.BufferedReader(retrieve);
            String line;
            while ( (line = in.readLine()) != null)
            {
                out.println(line);
            }
        }
        catch (java.io.IOException ex) {
            System.out.println(ex);
        }
    }

    public Pure.RecycleBroker.WasteType string_to_WasteType(String s)
    {
        int wasteInt = Integer.parseInt(s);
        Pure.RecycleBroker.WasteType _result = null;
        switch (wasteInt) {
            case 0:
                _result = Pure.RecycleBroker.WasteType.BROWN_GLASS;
                break;
            case 1:
                _result = Pure.RecycleBroker.WasteType.GREEN_GLASS;
                break;
            case 2:
                _result = Pure.RecycleBroker.WasteType.CLEAR_GLASS;
                break;
            case 3:
                _result = Pure.RecycleBroker.WasteType.SCRAP_STEEL;
                break;
            case 4:
                _result = Pure.RecycleBroker.WasteType.ALUMINIUM_CANS;
                break;
            case 5:
                _result = Pure.RecycleBroker.WasteType.PLASTIC_BOTTLES;
                break;
            case 6:
                _result = Pure.RecycleBroker.WasteType.WASTE_PAPER;
                break;
            default:
                _result = Pure.RecycleBroker.WasteType.BROWN_GLASS;
                break;
        }
        return _result;
    }

    public String WasteType_to_string(Pure.RecycleBroker.WasteType waste)
    {
        String _result = null;
        switch (waste.value()) {
            case Pure.RecycleBroker.WasteType._BROWN_GLASS:
                _result = "Brown Glass";
                break;
            case Pure.RecycleBroker.WasteType._GREEN_GLASS:
                _result = "Green Glass";
                break;
            case Pure.RecycleBroker.WasteType._CLEAR_GLASS:
                _result = "Clear Glass";
                break;
            case Pure.RecycleBroker.WasteType._SCRAP_STEEL:
                _result = "Scrap Steel";
                break;
            case Pure.RecycleBroker.WasteType._ALUMINIUM_CANS:
                _result = "Aluminium Cans";
                break;
            case Pure.RecycleBroker.WasteType._PLASTIC_BOTTLES:
                _result = "Plastic Bottles";
                break;
            case Pure.RecycleBroker.WasteType._WASTE_PAPER:
                _result = "Waste Paper";
                break;
            default:
                _result = "Brown Glass";
                break;
        }
        return _result;
    }

    // Private member variables
    private static ORB m_orb; 
    private static Pure.RecycleBroker.BranchOffice m_branch_office;
}

