#ifndef BOOKREPOSITORY_BORROWABLECOLLECTIONIMPL_H_
#define BOOKREPOSITORY_BORROWABLECOLLECTIONIMPL_H_

// Get rid of annoying VC++ Compiler Warning
#pragma warning( disable : 4290 ) 

#include "BookRepositoryS.hh"
#include "BookRepository_CollectionImpl.h"

#include "Borrower_DB.h"


class BookRepository_BorrowableCollectionImpl :
    public virtual POA_BookRepository::BorrowableCollection,
    public virtual BookRepository_CollectionImpl
{
public:
    BookRepository_BorrowableCollectionImpl(PortableServer::POA_ptr);

    virtual ~BookRepository_BorrowableCollectionImpl();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    static POA_BookRepository::BorrowableCollection*
    _create(PortableServer::POA_ptr);

    //----------
    // IDL operations
    //----------
    virtual void
    borrow_book(
        BookRepository::ISBN            book_id,
        const BookRepository::PersonName& borrower,
        BookRepository::Date_out        return_date
    ) throw (
        CORBA::SystemException,
        BookRepository::BorrowableCollection::Unavailable
    );

private: 
    // Private member variables.
    Borrower_DB               m_borrower_db;
    
    // Private member functions
    BookRepository::Date&
    current_date();

    void
    increment_date(BookRepository::Date& given_date, int days); 

    // The following are not implemented
    BookRepository_BorrowableCollectionImpl(
        const BookRepository_BorrowableCollectionImpl &
    );
    BookRepository_BorrowableCollectionImpl& operator=(
        const BookRepository_BorrowableCollectionImpl &
    );
}; 

#endif
