
#include <stdlib.h>
#include <iostream.h>
#include "BookRepository_CollectionImpl.h"


// _create() -- create a new servant.
POA_BookRepository::Collection*
BookRepository_CollectionImpl::_create(PortableServer::POA_ptr the_poa)
{
    return new BookRepository_CollectionImpl(the_poa);
}


// Constructor
BookRepository_CollectionImpl::BookRepository_CollectionImpl(
    PortableServer::POA_ptr the_poa
) :
    m_poaV(PortableServer::POA::_duplicate(the_poa)),
    m_number_of_books(1000),
    m_name_of_collectionV(CORBA::string_dup("AssortedBooks"))
{
}


// ~BookRepository_CollectionImpl destructor.
BookRepository_CollectionImpl::~BookRepository_CollectionImpl()
{
}

PortableServer::POA_ptr
BookRepository_CollectionImpl::_default_POA()
{
    return PortableServer::POA::_duplicate(m_poaV);
}



// is_in_collection()
BookRepository::FuzzyBoolean
BookRepository_CollectionImpl::is_in_collection(
    BookRepository::ISBN            book_id
) throw (
    CORBA::SystemException
)
{
    return BookRepository::UNKNOWN;
}


// number_of_books() -- Accessor
CORBA::Long
BookRepository_CollectionImpl::number_of_books()
throw (CORBA::SystemException)
{
    return m_number_of_books;
}


// name_of_collection() -- Accessor
char*
BookRepository_CollectionImpl::name_of_collection()
throw (CORBA::SystemException)

{
    return CORBA::string_dup(m_name_of_collectionV);
}


// name_of_collection() -- Modifier
void
BookRepository_CollectionImpl::name_of_collection(
    const char*                     _new_value
) throw (CORBA::SystemException)
{
    m_name_of_collectionV = CORBA::string_dup(_new_value);
}

