#ifndef BOOKREPOSITORY_FLEXIBLECOLLECTIONIMPL_H_
#define BOOKREPOSITORY_FLEXIBLECOLLECTIONIMPL_H_

// Get rid of annoying VC++ Compiler Warning
#pragma warning( disable : 4290 ) 

#include "BookRepositoryS.hh"
#include "BookRepository_BorrowableCollectionImpl.h"
#include "BookRepository_SearchableCollectionImpl.h"


class BookRepository_FlexibleCollectionImpl :
    public virtual POA_BookRepository::FlexibleCollection,
    public virtual BookRepository_BorrowableCollectionImpl,
    public virtual BookRepository_SearchableCollectionImpl
{
public:
    BookRepository_FlexibleCollectionImpl(PortableServer::POA_ptr);

    virtual ~BookRepository_FlexibleCollectionImpl();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    static POA_BookRepository::FlexibleCollection*
    _create(PortableServer::POA_ptr);

private: 
    // The following are not implemented
    BookRepository_FlexibleCollectionImpl(
        const BookRepository_FlexibleCollectionImpl &
    );
    BookRepository_FlexibleCollectionImpl& operator=(
        const BookRepository_FlexibleCollectionImpl &
    );
}; 

#endif
