#ifndef BOOKREPOSITORY_SEARCHABLECOLLECTIONIMPL_H_
#define BOOKREPOSITORY_SEARCHABLECOLLECTIONIMPL_H_

// Get rid of annoying VC++ Compiler Warning
#pragma warning( disable : 4290 ) 

#include "BookRepositoryS.hh"
#include "BookRepository_CollectionImpl.h"

#include "Collection_DB.h"


class BookRepository_SearchableCollectionImpl :
    public virtual POA_BookRepository::SearchableCollection,
    public virtual BookRepository_CollectionImpl
{
public:
    BookRepository_SearchableCollectionImpl(PortableServer::POA_ptr);

    virtual ~BookRepository_SearchableCollectionImpl();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    static POA_BookRepository::SearchableCollection*
    _create(PortableServer::POA_ptr);

    // Overriding inherited IDL operations
    virtual BookRepository::FuzzyBoolean
    is_in_collection(
        BookRepository::ISBN            book_id
    ) throw (
        CORBA::SystemException
    );

    //----------
    // IDL operations
    //----------
    virtual CORBA::Boolean
    find_by_title(
        const char*                     title,
        BookRepository::BookDetailsSeq_out books_found
    ) throw (
        CORBA::SystemException
    );

private: 
    // Private member variables.
    Collection_DB    m_collection_db;

    // The following are not implemented
    BookRepository_SearchableCollectionImpl(
        const BookRepository_SearchableCollectionImpl &
    );
    BookRepository_SearchableCollectionImpl& operator=(
        const BookRepository_SearchableCollectionImpl &
    );
}; 

#endif
