#ifndef _BORROWER_DB_
#define _BORROWER_DB_


// Use the Standard Template Library (STL)
#include <map>

// Inlude definitions from the stub code.
#include "BookRepository.hh"

class Borrower_DB {
public:
    struct LoanRecord {
        BookRepository::PersonName borrower;
        BookRepository::Date       return_date;
    };
    
    Borrower_DB();

    CORBA::Boolean
    get(CORBA::Long book_id, LoanRecord&);
    
    CORBA::Boolean
    put(CORBA::Long book_id, const LoanRecord&);

private:
    typedef std::map<CORBA::Long, LoanRecord> TableType;

    // Private member variables
    TableType                 m_borrow_table;

    // Not implemented for this class.
    Borrower_DB(const Borrower_DB&);
    Borrower_DB& operator=(const Borrower_DB&);
};


#endif
