//-----------------------------------------------
// class 'ObjectIdMapper'
//-----------------------------------------------

#include <sstream>
#include "ObjectIdMapper.h"

// Manipulation of 'ObjectId'
PortableServer::ObjectId *
ObjectIdMapper::make_ObjectId(const char * type, CORBA::Long key)
{
    std::ostringstream ost;

    ost << type << " " << (int) key;

    return PortableServer::string_to_ObjectId(ost.str().c_str());
}
    
CORBA::Long
ObjectIdMapper::extract_key_from_ObjectId(const PortableServer::ObjectId & oid)
{
    CORBA::String_var strV;
    std::string       type;
    CORBA::Long       key;

    strV = PortableServer::ObjectId_to_string(oid);
    std::string s = strV.in();
    std::istringstream ist(s);
    ist >> type >> key;

    return key;
}

char *
ObjectIdMapper::extract_type_from_ObjectId(const PortableServer::ObjectId & oid)
{
    CORBA::String_var strV;
    std::string       type;
    CORBA::Long       key;

    strV = PortableServer::ObjectId_to_string(oid);
    std::string s = strV.in();
    std::istringstream ist(s);
    ist >> type >> key;

    return CORBA::string_dup(type.c_str());
}
