#ifndef _POAMAPPER_H_
#define _POAMAPPER_H_

//---------------------
// A Singleton Class
//---------------------

#include <omg/PortableServer.hh>

// Use the Standard Template Library (STL)
#include <map>
#include <string>

class POAMapper {

public:
    static void addPOAEntry(const char* rep_id, PortableServer::POA_ptr poaP);
    
    static PortableServer::POA_ptr getPOA(const char* rep_id);
    
    // Destructor
    virtual ~POAMapper();

private:
    typedef std::map<std::string, PortableServer::POA_var> TableType;

    //--------------------------
    // Private Member Variables
    //--------------------------
    TableType                     m_table;

    //--------------------------
    // Private functions
    //--------------------------
    static POAMapper& thisMap();
    POAMapper();

    //Not defined in this class
    POAMapper(const POAMapper &);
    POAMapper & operator=(const POAMapper &);
};

#endif
