
// Servant which implements the RecycleBroker::BranchOffice interface.

#include <stdlib.h>
#include <iostream.h>
#include "RecycleBroker_BranchOffice_i.h"
#include "POAMapper.h"


// _create() -- create a new servant.
// Hides the difference between direct inheritance and tie servants
// For direct inheritance, simple create and return an instance of the servant.
// For tie, creates an instance of the tied class and the tie, return the tie.
//
POA_RecycleBroker::BranchOffice*
RecycleBroker_BranchOffice_i::_create(const char* address, CORBA::Long branch_id)
{
    return new RecycleBroker_BranchOffice_i(address, branch_id);
}


// RecycleBroker_BranchOffice_i constructor
//
// Note: since we use virtual inheritance, we must include an
// initialiser for all the virtual base class constructors that
// require arguments, even those that we inherit indirectly.
//
RecycleBroker_BranchOffice_i::RecycleBroker_BranchOffice_i(
    const char* address, CORBA::Long branch_id
) :
    RecycleBroker_Office_i(address, branch_id)
{
}


// ~RecycleBroker_BranchOffice_i destructor.
//
RecycleBroker_BranchOffice_i::~RecycleBroker_BranchOffice_i()
{
}

PortableServer::POA_ptr
RecycleBroker_BranchOffice_i::_default_POA()
{
    CORBA::String_var rep_idV = RecycleBroker::_tc_BranchOffice->id();
    return POAMapper::getPOA(rep_idV.in() );
}


