// Class: RecycleBroker_BranchOffice_i
// A POA servant which implements of the RecycleBroker::BranchOffice interface
//

#ifndef RECYCLEBROKER_BRANCHOFFICE_I_H_
#define RECYCLEBROKER_BRANCHOFFICE_I_H_

#include "RecycleBrokerS.hh"
#include "RecycleBroker_Office_i.h"


class RecycleBroker_BranchOffice_i :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_RecycleBroker::BranchOffice,
    public virtual RecycleBroker_Office_i
{
public:
    RecycleBroker_BranchOffice_i(const char* address, CORBA::Long branch_id);

    virtual ~RecycleBroker_BranchOffice_i();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    //    
    static POA_RecycleBroker::BranchOffice*
    _create(const char* address, CORBA::Long branch_id);

    virtual PortableServer::POA_ptr
    _default_POA();

private: 
    // The following are not implemented
    //
    RecycleBroker_BranchOffice_i(const RecycleBroker_BranchOffice_i &);
    RecycleBroker_BranchOffice_i& operator=(const RecycleBroker_BranchOffice_i &);
}; 

#endif
