// Class: RecycleBroker_Browsing_i
// A POA servant which implements of the RecycleBroker::Browsing interface
//

#ifndef RECYCLEBROKER_BROWSING_I_H_
#define RECYCLEBROKER_BROWSING_I_H_

#include "RecycleBrokerS.hh"


class RecycleBroker_Browsing_i :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_RecycleBroker::Browsing
{
public:
    RecycleBroker_Browsing_i(RecycleBroker::KeyType branch_id);

    virtual ~RecycleBroker_Browsing_i();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    //    
    static POA_RecycleBroker::Browsing*
    _create(RecycleBroker::KeyType branch_id);


    // IDL operations
    //
    virtual RecycleBroker::WasteItemAdmin_ptr
    get_waste_item_admin() IT_THROW_DECL((
        CORBA::SystemException
    ));

    virtual PortableServer::POA_ptr
    _default_POA();

private: 
    // Private members
    RecycleBroker::KeyType   m_branch_id;

    // The following are not implemented
    RecycleBroker_Browsing_i(const RecycleBroker_Browsing_i &);
    RecycleBroker_Browsing_i& operator=(const RecycleBroker_Browsing_i &);
}; 

#endif
