// Class: RecycleBroker_Customer_i
// A POA servant which implements of the RecycleBroker::Customer interface
//

#ifndef RECYCLEBROKER_CUSTOMER_I_H_
#define RECYCLEBROKER_CUSTOMER_I_H_

#include "RecycleBrokerS.hh"


class RecycleBroker_Customer_i :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_RecycleBroker::Customer
{
public:
    RecycleBroker_Customer_i(RecycleBroker::KeyType customer_id);
    RecycleBroker_Customer_i(const RecycleBroker::CustomerDetailsFull& data);

    virtual ~RecycleBroker_Customer_i();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    //    
    static POA_RecycleBroker::Customer*
    _create(RecycleBroker::KeyType customer_id);


    // IDL operations
    //
    virtual RecycleBroker::CustomerDetails*
    get_details() IT_THROW_DECL((
        CORBA::SystemException
    ));


    // IDL attributes
    //
    virtual char* name() IT_THROW_DECL((CORBA::SystemException));

    virtual void name(
        const char*                     _new_value
    ) IT_THROW_DECL((CORBA::SystemException));

    virtual char* address() IT_THROW_DECL((CORBA::SystemException));

    virtual void address(
        const char*                     _new_value
    ) IT_THROW_DECL((CORBA::SystemException));

    virtual char* email_address() IT_THROW_DECL((CORBA::SystemException));

    virtual void email_address(
        const char*                     _new_value
    ) IT_THROW_DECL((CORBA::SystemException));

    virtual char* password() IT_THROW_DECL((CORBA::SystemException));

    virtual void password(
        const char*                     _new_value
    ) IT_THROW_DECL((CORBA::SystemException));

    virtual RecycleBroker::KeyType branch_id() IT_THROW_DECL((CORBA::SystemException));

    virtual RecycleBroker::KeyType customer_id() IT_THROW_DECL((CORBA::SystemException));

    virtual PortableServer::POA_ptr
    _default_POA();

private: 
    // Cached customer record
    CORBA::Boolean                        m_hasValidCache;
    RecycleBroker::CustomerDetailsFull*   m_dataP;
    
    // Private functions
    void _update_db_from_cache();
 
    // The following are not implemented
    RecycleBroker_Customer_i(const RecycleBroker_Customer_i &);
    RecycleBroker_Customer_i& operator=(const RecycleBroker_Customer_i &);
}; 

#endif
