// Class: RecycleBroker_HeadOffice_i
// A POA servant which implements of the RecycleBroker::HeadOffice interface
//

#ifndef RECYCLEBROKER_HEADOFFICE_I_H_
#define RECYCLEBROKER_HEADOFFICE_I_H_

#include "RecycleBrokerS.hh"
#include "RecycleBroker_Office_i.h"


class RecycleBroker_HeadOffice_i :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_RecycleBroker::HeadOffice,
    public virtual RecycleBroker_Office_i
{
public:
    RecycleBroker_HeadOffice_i(const char* address, CORBA::Long branch_id);

    virtual ~RecycleBroker_HeadOffice_i();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    //    
    static POA_RecycleBroker::HeadOffice*
    _create(const char* address, CORBA::Long branch_id);


    // IDL operations
    //
    virtual void
    replicate_waste_item_details(
        const RecycleBroker::WasteItemDetailsFullSeq& detailsSeq
    ) IT_THROW_DECL((
        CORBA::SystemException
    ));

    virtual void
    replicate_customer_details(
        const RecycleBroker::CustomerDetailsFullSeq& detailsSeq
    ) IT_THROW_DECL((
        CORBA::SystemException
    ));

    virtual PortableServer::POA_ptr
    _default_POA();

private: 
    // The following are not implemented
    //
    RecycleBroker_HeadOffice_i(const RecycleBroker_HeadOffice_i &);
    RecycleBroker_HeadOffice_i& operator=(const RecycleBroker_HeadOffice_i &);
}; 

#endif
