// Servant which implements the RecycleBroker::OfficeAdmin interface.
//

#include <stdlib.h>
#include <iostream.h>
#include "RecycleBroker_OfficeAdmin_i.h"
#include "POAMapper.h"


// _create() -- create a new servant.
// Hides the difference between direct inheritance and tie servants
// For direct inheritance, simple create and return an instance of the servant.
// For tie, creates an instance of the tied class and the tie, return the tie.
//
POA_RecycleBroker::OfficeAdmin*
RecycleBroker_OfficeAdmin_i::_create()
{
    return new RecycleBroker_OfficeAdmin_i();
}


// RecycleBroker_OfficeAdmin_i constructor
//
// Note: since we use virtual inheritance, we must include an
// initialiser for all the virtual base class constructors that
// require arguments, even those that we inherit indirectly.
//
RecycleBroker_OfficeAdmin_i::RecycleBroker_OfficeAdmin_i()
{
    // Intentionally empty.
}


// ~RecycleBroker_OfficeAdmin_i destructor.
//
RecycleBroker_OfficeAdmin_i::~RecycleBroker_OfficeAdmin_i()
{
    // Intentionally empty.
    //
}


// get_all_details() -- Implements IDL operation "RecycleBroker::OfficeAdmin::get_all_details".
//
RecycleBroker::BranchDetailsSeq*
RecycleBroker_OfficeAdmin_i::get_all_details() IT_THROW_DECL((
    CORBA::SystemException
))
{
    // DUMMY IMPLEMENTATION
    cout << "RecycleBroker_OfficeAdmin_i::get_all_details(): called." << endl;

    RecycleBroker::BranchDetailsSeq* _result;
    _result = new RecycleBroker::BranchDetailsSeq; // allocate memory

    return _result;
}

PortableServer::POA_ptr
RecycleBroker_OfficeAdmin_i::_default_POA()
{
    CORBA::String_var rep_idV = RecycleBroker::_tc_OfficeAdmin->id();
    return POAMapper::getPOA(rep_idV.in() );
}

